<template>
  <ObForm
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isNew"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :label="dictionaryRu.modal.name"
          v-model="formData.name"
          :placeholder="dictionaryRu.modal.placeholder_name"
          :disabled="!isNew"
          property="name"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-8">
        <ob-input
          :label="dictionaryRu.modal.international_name"
          :placeholder="dictionaryRu.modal.placeholder_international_name"
          v-model="formData.international_name"
          :disabled="!isNew"
        />
      </div>
      <div class="col-xs-4">
        <ob-input
          :label="dictionaryRu.modal.abbr_name"
          :placeholder="dictionaryRu.modal.placeholder_abbr_name"
          v-model="formData.short_name"
          :disabled="!isNew"
          property="short_name"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-selector
          :label="dictionaryRu.modal.member_countries"
          :placeholder="dictionaryRu.modal.placeholder_member_countries"
          v-model="formData.members_uuid"
          :remote-opt="getCountries"
          :page-limit="300"
          :is-auto-complete="true"
          :is-multiselect="true"
          :is-standart="true"
          :is-dropdown="true"
          :disabled="!isNew"
          class="mb20"
        />
      </div>
    </div>
    <ob-modal
      ref="addCountries"
      :title="dictionaryRu.modal.placeholder_member_countries"
      custom-class="modal-large"
      :is-show-controls="true"
      :is-read-only="true"
    >
      <country-list :selected-callback="selectedCountry" />
    </ob-modal>
  </ObForm>
</template>

<script>
import CountryList from "./CountryList";
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import models from "@/models";
import api from "@/api";
import cloneDeep from "clone-deep";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObModal from "common-components/src/obComponents/obModal";
import ObSelector from "common-components/src/obComponents/obSelect";
import dropdownEvents from "@/mixins/dictionaries/dropdown-events";
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__common__customs_unions'

export default {
  name: "CustomUnion",
  components: {
    ObModal,
    ObInput,
    ObForm,
    CountryList,
    ObSelector
  },
  mixins: [FormValidationMixin, dropdownEvents],
  props: {
    disabledForm: {
      type: Boolean,
      default: true
    },
    dataSource: {
      type: Object,
      required: true,
      default: () => {}
    },
    modal: {
      type: Object,
      required: true,
      default: () => {}
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  created() {},
  computed: {
    formModel() {
      return models.customUnion;
    },
    isNew() {
      return !this.formData.uuid;
    }
  },
  methods: {
    addCountries() {
      this.$refs.addCountries.open();
    },
    selectedCountry(data) {
      data.denomination = data.name;
      let _member = this.formData.members.find(member => {
        return member.uuid === data.uuid;
      });
      if (!_member) {
        this.formData.members.push(data);
      }
      if (this.formData.members_uuid.indexOf(data.uuid) < 0) {
        this.formData.members_uuid.push(data.uuid);
      }
      this.$refs.addCountries.close();
    },
    onSubmitHandler() {
      let data = cloneDeep(this.formData);
      data.members = data.members_uuid;

      this.$emit("submit", { formData: data, model: this.formModel });
    },
    async getCountries({ page, size, query }) {
      try {
        if (this.isNew) {
          return await api.general.getCountriesList1(page, size, query, null);
        } else {
          return await api.general.getCountriesList2(page, size, query, null);
        }
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка загрузки данных"
        });
      }
    }
  }
};
</script>

<style lang="scss" scoped>
.input-wrap {
  margin-bottom: 10px;
}
</style>
